#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

void RunFlib(entity_p pEnt, int dwTime)
{
	flib_data_p pData = (flib_data_p)pEnt->pvData[0];
	player_data_p pPData;
	if(pData->pMaster)
		pPData = (player_data_p)pData->pMaster->pvData[0];
	else
		pPData = NULL;

	float fvDiff[2];
	if(pData->bLift)
	{
		float fvOffset[2] = { -4.0f, -32.0f };
		if(pPData  &&  pPData->bFlip)
			fvOffset[0] = 4.0f;
		Vec2Add(pData->pMaster->fvPos, fvOffset, fvDiff);
		Vec2Subtract(fvDiff, pEnt->fvPos, fvDiff);
		Vec2AddMul(pEnt->fvPos, fvDiff, 0.15f, pEnt->fvPos);
	}
	else
	{
		Vec2Add(pData->pMaster->fvPos, pData->fvDest, fvDiff);
		Vec2Subtract(fvDiff, pEnt->fvPos, fvDiff);
		Vec2AddMul(pEnt->fvPos, fvDiff, 0.05f, pEnt->fvPos);
	}

	if((rand()%800) == 0)
		pData->dwBlink = dwTime+10;
}

void PickupFlib(entity_p pEnt, entity_p pPlayer)
{
	flib_data_p pData = (flib_data_p)pEnt->pvData[0];
	player_data_p pPData = (player_data_p)pPlayer->pvData[0];

	pData->pMaster = pPlayer;
	pData->fvDest[0] = 0.0f;
	pData->fvDest[1] = -60.0f;

	pPData->pFlib = pEnt;
	pPData->pFlibData = pData;

	pEnt->m_AltUse = NULL;
	pEnt->m_Run = RunFlib;
	pEnt->bSolid = false;
	pEnt->fvGravityMultiplier[0] = 0.0f;
	pEnt->fvGravityMultiplier[1] = 0.0f;

	g_pImports->m_EntityActive(pEnt);
	g_pImports->m_EntityStatic(pEnt);

	if(!pData->sGlobal.empty())
		g_pImports->m_SetGlobalFloat(pData->sGlobal, 1.0f);
}

void DrawFlib(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	flib_data_p pData = (flib_data_p)pEnt->pvData[0];

	int dwRPos = pData->bLift?((g_pImports->dwGameTime*8)%256):((g_pImports->dwGameTime*4)%256);
	g_pImports->m_RotateSprite(pDest, pData->pFanBmp, pEnt->fvPos[0]-20-dwSX, pEnt->fvPos[1]-8-dwSY, -dwRPos);
	g_pImports->m_RotateSprite(pDest, pData->pFanBmp, pEnt->fvPos[0]+4-dwSX, pEnt->fvPos[1]-8-dwSY, dwRPos);

	g_pImports->m_DrawSprite(pDest, pData->dwBlink>=g_pImports->dwGameTime?pData->pBlinkBmp:pData->pMainBmp, pEnt->fvPos[0]-12-dwSX, pEnt->fvPos[1]-12-dwSY);
}

entity_p SpawnFlib(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 12.0f;
	pEnt->fvSize[1] = 12.0f;
	pEnt->bSolid = true;

	flib_data_p pData = new flib_data_t;
	pEnt->pvData[0] = pData;
	pData->pMainBmp = g_pImports->m_LoadSprite("Flib.bmp");
	pData->pBlinkBmp = g_pImports->m_LoadSprite("FlibBlink.bmp");
	pData->pFanBmp = g_pImports->m_LoadSprite("Rotor.bmp");
	pData->dwBlink = 0;
	pData->bLift = false;
	pData->sGlobal = svVars[0];
	pData->pMaster = NULL;

	pEnt->m_Draw = DrawFlib;
	pEnt->m_AltUse = PickupFlib;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);

	if(!svVars[0].empty()  &&  g_pImports->m_GetGlobalFloat(svVars[0]) > 0.0f)
	{
		pData->pMaster = g_pImports->pPlayer;
		player_data_p pPData = (player_data_p)g_pImports->pPlayer->pvData[0];

		pData->fvDest[0] = 0.0f;
		pData->fvDest[1] = -60.0f;

		pPData->pFlib = pEnt;
		pPData->pFlibData = pData;

		pEnt->m_AltUse = NULL;
		pEnt->m_Run = RunFlib;
		pEnt->bSolid = false;
		pEnt->fvGravityMultiplier[0] = 0.0f;
		pEnt->fvGravityMultiplier[1] = 0.0f;

		g_pImports->m_EntityActive(pEnt);
		g_pImports->m_EntityStatic(pEnt);
	}

	return pEnt;
}
