#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

typedef struct key_data_s {
	int						dwNumber;
	string					sGlobal;
} key_data_t, *key_data_p;

typedef struct lock_data_s {
	int						dwNumber;
	string					sTrigger;
	string					sV1;
	string					sV2;
} lock_data_t, *lock_data_p;

BITMAP* g_pvKeyBmp[32];

void KeyPickup(entity_p pEnt, entity_p pPlayer)
{
	key_data_p pData = (key_data_p)pEnt->pvData[0];
	((player_data_p)pPlayer->pvData[0])->dwKeysHeld |= (1<<pData->dwNumber);
	pEnt->bGarbage = true;
	if(!pData->sGlobal.empty())
		g_pImports->m_SetGlobalFloat(pData->sGlobal, 1.0f);
}

void DrawKey(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	key_data_p pData = (key_data_p)pEnt->pvData[0];
	g_pImports->m_DrawSprite(pDest, g_pvKeyBmp[pData->dwNumber], pEnt->fvPos[0]-dwSX-(g_pvKeyBmp[pData->dwNumber]->w>>1), pEnt->fvPos[1]-dwSY-(g_pvKeyBmp[pData->dwNumber]->h>>1));
}

entity_p SpawnKey(string sType, string sName, int dwvPos[], string svVars[])
{
	if(!svVars[1].empty()  &&  g_pImports->m_GetGlobalFloat(svVars[1]) > 0.0f)
		return NULL;

	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = "key";
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 16.0f;
	pEnt->fvSize[1] = 16.0f;
	pEnt->bSolid = true;

	key_data_p pData = new key_data_t;
	pEnt->pvData[0] = pData;
	pData->dwNumber = atoi(svVars[0].c_str());
	pData->sGlobal = svVars[1];

	pEnt->m_Draw = DrawKey;
	pEnt->m_AltUse = KeyPickup;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);

	return pEnt;
}

void UseLock(entity_p pEnt, entity_p pPlayer)
{
	lock_data_p pData = (lock_data_p)pEnt->pvData[0];

	player_data_p pPData = (player_data_p)pPlayer->pvData[0];
	if((pPData->dwKeysHeld&(1<<pData->dwNumber)) != (1<<pData->dwNumber))
		return;

	pPData->dwKeysHeld &= (1<<pData->dwNumber)^0xFFFFFFFF;

	entity_p pTEnt = g_pImports->m_FindEntityByName(pData->sTrigger, NULL);
	if(pTEnt  &&  pTEnt->m_Trigger)
	{
		pTEnt->m_Trigger(pTEnt, pEnt, pData->sV1, pData->sV2);
	}

	pEnt->bGarbage = true;
}

entity_p SpawnLock(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 16.0f;
	pEnt->fvSize[1] = 16.0f;

	lock_data_p pData = new lock_data_t;
	pEnt->pvData[0] = pData;
	pData->sTrigger = svVars[0];
	pData->sV1 = svVars[1];
	pData->sV2 = svVars[2];
	pData->dwNumber = atoi(svVars[3].c_str());

	pEnt->m_Use = UseLock;
	pEnt->m_AltUse = UseLock;

	return pEnt;
}
