#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"
#include "Utils.h"

bool ShibTakeDamage(entity_p pEnt, particle_p pPtc, int dwDamage)
{
	shib_data_p pData = (shib_data_p)pEnt->pvData[0];

	pData->dwSheildPower -= dwDamage;
	if(pData->dwSheildPower < 0)
	{
		pData->dwSheildPower = 0;
		pData->dwChargeTime = g_pImports->dwGameTime+800;
	}
	if(pData->dwSheildPower > 100)
		pData->dwSheildPower = 100;

	return true;
}

void RunShib(entity_p pEnt, int dwTime)
{
	shib_data_p pData = (shib_data_p)pEnt->pvData[0];
	player_data_p pPData;
	if(pData->pMaster)
		pPData = (player_data_p)pData->pMaster->pvData[0];
	else
		pPData = NULL;

	float fvDiff[2];
	Vec2Add(pData->pMaster->fvPos, pData->fvDest, fvDiff);
	Vec2Subtract(fvDiff, pEnt->fvPos, fvDiff);
	Vec2AddMul(pEnt->fvPos, fvDiff, (Vec2LengthEx(fvDiff)<=400.0f)?0.03f:0.075f, pEnt->fvPos);

	if(pPData->bFlip)
		pData->fvDest[0] = -ABS(pData->fvDest[0]);
	else
		pData->fvDest[0] = ABS(pData->fvDest[0]);

	if(pData->dwSheildPower)
	{
		if(pPData->bFlip)
		{
			pData->fvDest[0] = -ABS(pData->fvDest[0]);
			g_pImports->m_SetPlatformMode(pData->pSheild[0], false, false);
			g_pImports->m_SetPlatformMode(pData->pSheild[1], false, true);
		}
		else
		{
			pData->fvDest[0] = ABS(pData->fvDest[0]);
			g_pImports->m_SetPlatformMode(pData->pSheild[0], false, true);
			g_pImports->m_SetPlatformMode(pData->pSheild[1], false, false);
		}
	}
	else
	{
		g_pImports->m_SetPlatformMode(pData->pSheild[0], false, false);
		g_pImports->m_SetPlatformMode(pData->pSheild[1], false, false);
	}

	if(g_pImports->dwGameTime >= pData->dwChargeTime  &&  (g_pImports->dwGameTime%5) == 0)
			pData->dwSheildPower++;
	if(pData->dwSheildPower > 100)
		pData->dwSheildPower = 100;
}

void PickupShib(entity_p pEnt, entity_p pPlayer)
{
	shib_data_p pData = (shib_data_p)pEnt->pvData[0];
	player_data_p pPData = (player_data_p)pPlayer->pvData[0];

	pData->pMaster = pPlayer;
	pData->fvDest[0] = 40.0f;
	pData->fvDest[1] = -4.0f;

	pPData->pShib = pEnt;
	pPData->pShibData = pData;

	pEnt->m_AltUse = NULL;
	pEnt->m_Run = RunShib;
	pEnt->m_TakeDamage = ShibTakeDamage;

	pEnt->bSolid = false;
	pEnt->fvGravityMultiplier[0] = 0.0f;
	pEnt->fvGravityMultiplier[1] = 0.0f;

	g_pImports->m_EntityActive(pEnt);
	g_pImports->m_EntityStatic(pEnt);

	if(!pData->sGlobal.empty())
		g_pImports->m_SetGlobalFloat(pData->sGlobal, 1.0f);
}

void DrawShib(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	shib_data_p pData = (shib_data_p)pEnt->pvData[0];
	player_data_p pPData;
	if(pData->pMaster)
		pPData = (player_data_p)pData->pMaster->pvData[0];
	else
		pPData = NULL;

	if(pData->pMaster)
	{
		if(pPData->bFlip)
		{
			g_pImports->m_DrawSpriteHFlip(pDest, pData->pSideBmp[(g_pImports->dwGameTime>>4)%2], pEnt->fvPos[0]-18-dwSX, pEnt->fvPos[1]-16-dwSY);
			if(pData->dwSheildPower)
				DrawZap(pDest, pEnt->fvPos[0]-18-dwSX, pEnt->fvPos[1]-20-dwSY, pEnt->fvPos[0]-18-dwSX, pEnt->fvPos[1]+28-dwSY, 6, 3, 6.0f, makecol(255, 255, pData->dwSheildPower*2.55f), makecol(255-pData->dwSheildPower*2.55f, 0, pData->dwSheildPower*2.55f));
		}
		else
		{
			g_pImports->m_DrawSprite(pDest, pData->pSideBmp[(g_pImports->dwGameTime>>4)%2], pEnt->fvPos[0]-18-dwSX, pEnt->fvPos[1]-16-dwSY);
			if(pData->dwSheildPower)
				DrawZap(pDest, pEnt->fvPos[0]+18-dwSX, pEnt->fvPos[1]-20-dwSY, pEnt->fvPos[0]+18-dwSX, pEnt->fvPos[1]+28-dwSY, 6, 3, 6.0f, makecol(255, 255, pData->dwSheildPower*2.55f), makecol(255-pData->dwSheildPower*2.55f, 0, pData->dwSheildPower*2.55f));
		}
	}
	else
	{
		g_pImports->m_DrawSprite(pDest, pData->pMainBmp, pEnt->fvPos[0]-19-dwSX, pEnt->fvPos[1]-18-dwSY);
	}
}

entity_p SpawnShib(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 12.0f;
	pEnt->fvSize[1] = 12.0f;
	pEnt->bSolid = true;

	shib_data_p pData = new shib_data_t;
	pEnt->pvData[0] = pData;
	pData->pMainBmp = g_pImports->m_LoadSprite("Shib.bmp");
	pData->pSideBmp[0] = g_pImports->m_LoadSprite("ShibSide.bmp");
	pData->pSideBmp[1] = g_pImports->m_LoadSprite("ShibSide2.bmp");
	pData->sGlobal = svVars[0];
	pData->pMaster = NULL;
	pData->dwSheildPower = 100;
	pData->dwChargeTime = 0;

	pData->pSheild[0] = g_pImports->m_AddPlatform(pEnt);
	g_pImports->m_SetPlatformMode(pData->pSheild[0], false, false);
	g_pImports->m_PlatformAddBlocker(pData->pSheild[0], 18, -20, 18, 28);

	pData->pSheild[1] = g_pImports->m_AddPlatform(pEnt);
	g_pImports->m_SetPlatformMode(pData->pSheild[1], false, false);
	g_pImports->m_PlatformAddBlocker(pData->pSheild[1], -18, 28, -18, -20);

	pEnt->m_Draw = DrawShib;
	pEnt->m_AltUse = PickupShib;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);

	if(!svVars[0].empty()  &&  g_pImports->m_GetGlobalFloat(svVars[0]) > 0.0f)
	{
		pData->pMaster = g_pImports->pPlayer;
		player_data_p pPData = (player_data_p)g_pImports->pPlayer->pvData[0];

		pData->fvDest[0] = 40.0f;
		pData->fvDest[1] = -4.0f;

		pPData->pShib = pEnt;
		pPData->pShibData = pData;

		pEnt->m_AltUse = NULL;
		pEnt->m_Run = RunShib;
		pEnt->m_TakeDamage = ShibTakeDamage;

		pEnt->bSolid = false;
		pEnt->fvGravityMultiplier[0] = 0.0f;
		pEnt->fvGravityMultiplier[1] = 0.0f;

		g_pImports->m_EntityActive(pEnt);
		g_pImports->m_EntityStatic(pEnt);
	}

	return pEnt;
}
