#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

void cbTriggerOnce(trigger_zone_s* pTrigger, entity_p pEntity, void* pData)
{
	trigger_data_p pTData = (trigger_data_p)pData;

	entity_p pEnt = g_pImports->m_FindEntityByName(pTData->sTrigger, NULL);
	while(pEnt)
	{
		if(pEnt->m_Trigger)
			pEnt->m_Trigger(pEnt, NULL, pTData->sV1, pTData->sV2);
		pEnt = g_pImports->m_FindEntityByName(pTData->sTrigger, pEnt);
	}

	pTrigger->bActive = false;
}

entity_p SpawnTriggerOnce(string sType, string sName, int dwvPos[], string svVars[])
{
	trigger_zone_p pZone = g_pImports->m_AddTrigger();
	pZone->bActive = true;
	pZone->fvPos[0] = dwvPos[0];
	pZone->fvPos[1] = dwvPos[1];
	pZone->fvPos[2] = dwvPos[2];
	pZone->fvPos[3] = dwvPos[3];
	pZone->m_Trigger = cbTriggerOnce;

	trigger_data_p pData = new trigger_data_t;
	pData->sTrigger = svVars[0];
	pData->sV1 = svVars[1];
	pData->sV2 = svVars[2];
	pZone->pData = pData;

	return NULL;
}

void cbTriggerMultiple(trigger_zone_s* pTrigger, entity_p pEntity, void* pData)
{
	trigger_data_p pTData = (trigger_data_p)pData;

	if(pTData->dwTime > g_pImports->dwGameTime)
		return;

	entity_p pEnt = g_pImports->m_FindEntityByName(pTData->sTrigger, NULL);
	while(pEnt)
	{
		if(pEnt->m_Trigger)
			pEnt->m_Trigger(pEnt, NULL, pTData->sV1, pTData->sV2);
		pEnt = g_pImports->m_FindEntityByName(pTData->sTrigger, pEnt);
	}

	pTData->dwTime = g_pImports->dwGameTime+pTData->dwDelay;
}

entity_p SpawnTriggerMultiple(string sType, string sName, int dwvPos[], string svVars[])
{
	trigger_zone_p pZone = g_pImports->m_AddTrigger();
	pZone->bActive = true;
	pZone->fvPos[0] = dwvPos[0];
	pZone->fvPos[1] = dwvPos[1];
	pZone->fvPos[2] = dwvPos[2];
	pZone->fvPos[3] = dwvPos[3];
	pZone->m_Trigger = cbTriggerOnce;

	trigger_data_p pData = new trigger_data_t;
	pZone->pData = pData;
	pData->sTrigger = svVars[0];
	pData->sV1 = svVars[1];
	pData->sV2 = svVars[2];
	pData->dwDelay = atoi(svVars[3].c_str());
	pData->dwTime = 0;

	return NULL;
}
