#include "PDLL.h"
#include "../dll_shared.h"
#include "dll_common.h"
#include "Vectors.h"

bool cbRayTouch(particle_s* pPtc, struct entity_s* pEnt, float* fvClip)
{
	int dwR;
	particle_p pNP;
	for(int lp=0; lp<15; lp++)
	{
		pNP= g_pImports->m_CreateParticle();
		if(pNP)
		{
			pNP->bDraw = true;
			pNP->bGravity = true;
			pNP->bLarge = true;
			dwR = rand()%256;
			pNP->dwColor = makecol(dwR, dwR, 255);
			pNP->fvVel[0] = ((rand()%201)-100)/5.0f;
			pNP->fvVel[1] = ((rand()%201)-100)/5.0f;
			pNP->fvPos[0] = pPtc->fvPos[0];
			pNP->fvPos[1] = pPtc->fvPos[1];
			pNP->dwDeath = g_pImports->dwGameTime+50+rand()%50;
		}
	}

	g_pImports->m_DeleteParticle(pPtc);

	return true;
}

bool cbPtcTouch(particle_s* pPtc, struct entity_s* pEnt, float* fvClip)
{
	Vec2AddMul(pPtc->fvVel, fvClip, -Vec2Dot(fvClip, pPtc->fvVel)*2, pPtc->fvVel);
	pPtc->fAngle = GB_Atan2(pPtc->fvVel[0], -pPtc->fvVel[1]);

	if(pEnt)
	{
		cbRayTouch(pPtc, pEnt, fvClip);

		if(pEnt->m_TakeDamage)
			pEnt->m_TakeDamage(pEnt, pPtc, 10);
	}

	return true;
}

int RaygunFire(player_weapon_s* pWeapon, entity_p pEnt, int dwTime, int dwPower, float fvPos[], float fvDir[], float fvPerp[])
{
	particle_p pPtc = g_pImports->m_CreateParticle();
	if(pPtc)
	{
		pPtc->bDraw = true;
		pPtc->dwDeath = dwTime+400;
		Vec2AddMul(fvPos, fvDir, 34.0f, pPtc->fvPos);
		Vec2AddMul(pPtc->fvPos, fvPerp, 6.0f, pPtc->fvPos);
		Vec2Multiply(fvDir, 400.0f, pPtc->fvVel);
		pPtc->pBmp = g_pImports->m_LoadSprite("Ray.bmp");
		pPtc->fAngle = GB_Atan2(fvDir[0], -fvDir[1]);
		pPtc->m_Touch = cbPtcTouch;

		g_pImports->m_PlaySampleAtPoint((SAMPLE*)pWeapon->pvData[0], pPtc->fvPos[0], pPtc->fvPos[1], 0.5f, 2.5f, 192);
	}

	return dwTime+20;
}

void RaygunDraw(entity_p pEnt, BITMAP* pDest, int dwSX, int dwSY)
{
	BITMAP* pBmp = (BITMAP*)pEnt->pvData[0];
	g_pImports->m_DrawSprite(pDest, pBmp, pEnt->fvPos[0]-(pBmp->w>>1)-dwSX, pEnt->fvPos[1]-(pBmp->h>>1)-dwSY);
}

void RaygunPickup(entity_p pEnt, entity_p pPlayer)
{
	player_weapon_p pWeap = new player_weapon_t;
	pWeap->dwvOffset[0] = 0;
	pWeap->dwvOffset[1] = 0;
	pWeap->pBmp = g_pImports->m_LoadSprite("Raygun.bmp");
	pWeap->m_Fire = RaygunFire;
	pWeap->pvData[0] = g_pImports->m_LoadSample("Ion");

	AttachWeaponToPlayer(pPlayer, pWeap);

	pEnt->bGarbage = true;
}

entity_p SpawnRaygun(string sType, string sName, int dwvPos[], string svVars[])
{
	entity_p pEnt = g_pImports->m_NewEntity();

	pEnt->sName = sName;
	pEnt->sClass = sType;
	pEnt->fvPos[0] = (dwvPos[0]+dwvPos[2])>>1;
	pEnt->fvPos[1] = (dwvPos[1]+dwvPos[3])>>1;
	pEnt->fvVel[0] = 0.0f;
	pEnt->fvVel[1] = 0.0f;
	pEnt->fvSize[0] = 16.0f;
	pEnt->fvSize[1] = 12.0f;
	pEnt->bSolid = true;

	pEnt->pvData[0] = g_pImports->m_LoadSprite("itemRaygun.bmp");

	pEnt->m_AltUse = RaygunPickup;
	pEnt->m_Draw = RaygunDraw;

	g_pImports->m_EntityVisible(pEnt);
	g_pImports->m_EntityMobile(pEnt);

	return pEnt;
}
