#include <allegro.h>
#include <winalleg.h>
#include "AppRunner.h"

volatile int g_dwMainTime = 0;
int g_dwGameTime = 0;

void GameTimer()
{
	g_dwMainTime++;
}
END_OF_FUNCTION(GameTimer);

string GetString(string sLabel, string sDef)
{
	int dwOESize = CGUIEventHandler::pEventHandler->svEvents.size();

	string sValue = sDef;

	clear_keybuf();

	bool bDone = false;
	bool bRedraw = true;
	while(!bDone)
	{
		while(keypressed())
		{
			int c = readkey();
			int k = c>>8;
			c &= 0xFF;

			if(isprint(c) && k!=KEY_ENTER)
			{
				sValue += c;
			}
			if(c=='\b' && !sValue.empty())
			{
				sValue = sValue.substr(0, sValue.size()-1);
			}
			if(k==KEY_ENTER)
			{
				while(key[KEY_ENTER]);
				clear_keybuf();

				CGUIEventHandler::pEventHandler->svEvents.resize(dwOESize);
//				while(CGUIEventHandler::GetEvent().dwAll);
				g_dwMainTime = g_dwGameTime;

				return sValue;
			}
			bRedraw = true;
		}

		if(bRedraw)
		{
			bRedraw = false;

			clear(screen);
			textprintf(screen, font, 4, 4, makecol(255, 255, 255), "%s>%s|", sLabel.c_str(), sValue.c_str());
		}
	}

	CGUIEventHandler::pEventHandler->svEvents.resize(dwOESize);
//	while(CGUIEventHandler::GetEvent().dwAll);
	g_dwMainTime = g_dwGameTime;

	return "";
}

CAppRunner::CAppRunner()
{
	LOCK_FUNCTION(GameTimer);
	LOCK_VARIABLE(g_dwMainTime);

	set_keyboard_rate(0, 0);

	CGUIEventHandler::Register();
}

CAppRunner::~CAppRunner()
{
}

void CAppRunner::Start(CApp* pApp)
{
	if(!pApp)
		return;

	bool bMouseMode = false;

	pvApps.clear();
	pvApps.push_front(pApp);

	BITMAP* pBB = create_bitmap(SCREEN_W, SCREEN_H);

	install_int(GameTimer, pApp->TickPeriod());

	m_pApp = pApp;
	gb_event_t sEvent;
	while(m_pApp)
	{
		while(g_dwGameTime < g_dwMainTime)
		{
			g_dwGameTime++;

			if(m_pApp)
				ChangeApp(m_pApp->Run(g_dwGameTime));
		}

		while(m_pApp  &&  (sEvent = CGUIEventHandler::GetEvent()).dwAll)
		{
			if(sEvent.ucEvent == GBE_KEY_PRESS)
			{
				if(sEvent.wKey&0x80)
				{
					if(m_pApp->pvKeyFuncs[sEvent.wKey])
					{
						if(!ChangeApp(m_pApp->pvKeyFuncs[sEvent.wKey](m_pApp, true, sEvent.wKey&0x7F)))
							ChangeApp(m_pApp->Event(sEvent));
					}
					else
					{
						ChangeApp(m_pApp->Event(sEvent));
					}
				}
				else
				{
					if(m_pApp->pvKeyFuncs[sEvent.wKey])
					{
						if(!ChangeApp(m_pApp->pvKeyFuncs[sEvent.wKey](m_pApp, false, sEvent.wKey&0x7F)))
							ChangeApp(m_pApp->Event(sEvent));
					}
					else
					{
						ChangeApp(m_pApp->Event(sEvent));
					}
				}
			}
			else
			{
				if(!ChangeApp(m_pApp->MouseEvent(sEvent.ucEvent, mouse_x, mouse_y)))
					ChangeApp(m_pApp->Event(sEvent));
			}
		}

		if(m_pApp)
		{
			if(m_pApp->bShowMouse)
			{
				if(m_pApp->Draw(pBB))
				{
					if(m_pApp->bAltMouse)
					{
						if(!bMouseMode)
						{
							bMouseMode = true;
							show_mouse(screen);
						}

						scare_mouse();
						blit(pBB, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
						unscare_mouse();
					}
					else
					{
						if(bMouseMode)
						{
							bMouseMode = false;
						}

						show_mouse(pBB);
						blit(pBB, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
						show_mouse(NULL);
					}
				}
			}
			else
			{
				if(bMouseMode)
				{
					bMouseMode = false;
					show_mouse(NULL);
				}

				if(m_pApp->Draw(pBB))
					blit(pBB, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			}
		}
	}
}

bool CAppRunner::ChangeApp(CApp* pApp)
{
	if(pApp)
	{
		if(pApp != m_pApp)
		{
			m_pApp = pApp;
			pvApps.push_front(pApp);
			return true;
		}
	}
	else
	{
		if(m_pApp->bAutoDelete)
			delete m_pApp;

		pvApps.pop_front();

		if(pvApps.empty())
		{
			m_pApp = NULL;
			return true;
		}
		else
		{
			m_pApp = pvApps.front();
			return true;
		}
	}

	return false;
}
