#ifndef GLOBALS_H
#define GLOBALS_H

#include "dll_shared.h"
#include <string>
#include <map>
#include <list>

using namespace std;

typedef struct glob_string_callback_s {
	glob_string_callback_func_t	m_OnChange;
	void*					pData;
	bool					operator== (glob_string_callback_s sOther)
	{
		return sOther.m_OnChange == m_OnChange  &&  sOther.pData == pData;
	}
} glob_string_callback_t, *glob_string_callback_p;
typedef list<glob_string_callback_t> glob_string_callback_list_t;

typedef struct glob_string_s {
	glob_string_s()				{ sValue = ""; };
	glob_string_s(string sVal)	{ sValue = sVal; };

	string					sValue;
	glob_string_callback_list_t svCallbacks;

	operator string()	{ return sValue; };
} glob_string_t, *glob_string_p;


typedef struct glob_float_callback_s {
	glob_float_callback_func_t	m_OnChange;
	void*					pData;
	bool					operator== (glob_float_callback_s sOther)
	{
		return sOther.m_OnChange == m_OnChange  &&  sOther.pData == pData;
	}
} glob_float_callback_t, *glob_float_callback_p;
typedef list<glob_float_callback_t> glob_float_callback_list_t;

typedef struct glob_float_s {
	glob_float_s()				{ fValue = 0.0f; };
	glob_float_s(float fVal)	{ fValue = fVal; };

	float					fValue;
	glob_float_callback_list_t svCallbacks;

	operator float()	{ return fValue; };
} glob_float_t, *glob_float_p;

typedef map<const string, glob_string_t> global_string_list_t;
typedef map<const string, glob_float_t> global_number_list_t;

void ClearGlobals();
void SetGlobalString(const string sName, const string sValue);
string GetGlobalString(const string sName);
void SetGlobalFloat(const string sName, const float fValue);
float GetGlobalFloat(const string sName);
void AddGlobalStringCallback(string sName, glob_string_callback_func_t pFunc, void* pData);
void RemoveGlobalStringCallback(string sName, glob_string_callback_func_t pFunc, void* pData);
void AddGlobalFloatCallback(string sName, glob_float_callback_func_t pFunc, void* pData);
void RemoveGlobalFloatCallback(string sName, glob_float_callback_func_t pFunc, void* pData);

#endif // GLOBALS_H
