#include <allegro.h>
#include <winalleg.h>
#include "dll_shared.h"
#include "Collide.h"
#include <algorithm>

using namespace std;

#define MAX_PARTICLES 4096

particle_t g_svParticles[MAX_PARTICLES];
int g_dwParticleCount = 0;

particle_p CreateParticle()
{
	if(g_dwParticleCount >= MAX_PARTICLES)
		return NULL;

	particle_p pPtc = g_svParticles;
	while(pPtc->bActive)
		++pPtc;

	memset(pPtc, 0, sizeof(particle_t));
	pPtc->bActive = true;

	g_dwParticleCount++;

	return pPtc;
}

void DeleteParticle(particle_p pPtc)
{
	if(pPtc->bActive)
	{
		pPtc->bActive = false;
		g_dwParticleCount--;
	}
}

void RunParticles(int dwTime)
{
	int lp;
	particle_p pPtc=g_svParticles;
	for(lp=0; lp<MAX_PARTICLES; ++lp, ++pPtc)
	{
		if(pPtc->m_Run)
			pPtc->m_Run(pPtc, dwTime);
	}
}

void MoveParticles(collision_quadmap_p pQuadMap, int dwTime)
{
	float fX, fY, fD;
	float fvClip[2];
	int lp;
	particle_p pPtc=g_svParticles;
	entity_p pEnt = NULL;
	for(lp=0; lp<MAX_PARTICLES; ++lp, ++pPtc)
	{
		if(pPtc->bActive)
		{
			if(pPtc->dwDeath <= dwTime)
			{
				DeleteParticle(pPtc);
			}
			else
			{
				if(pPtc->bGravity)
					pPtc->fvVel[1] += 2.5f;

				if(pPtc->m_Touch)
				{
					fX = pPtc->fvPos[0]+pPtc->fvVel[0]*0.01f;
					fY = pPtc->fvPos[1]+pPtc->fvVel[1]*0.01f;
					fvClip[0] = 0.0f;
					fvClip[1] = 0.0f;
					fD = TraceLine_Blocker(pQuadMap, pPtc->fvPos[0], pPtc->fvPos[1], fX, fY, fvClip, pEnt);
					if(fD < 0.999f)
					{
						if(pPtc->m_Touch(pPtc, pEnt, fvClip))
						{
							pPtc->fvPos[0] = fX;
							pPtc->fvPos[1] = fY;
						}
						else
						{
							pPtc->fvPos[0] += pPtc->fvVel[0]*0.01f;
							pPtc->fvPos[1] += pPtc->fvVel[1]*0.01f;
						}
					}
					else
					{
						pPtc->fvPos[0] = fX;
						pPtc->fvPos[1] = fY;
					}
				}
				else
				{
					pPtc->fvPos[0] += pPtc->fvVel[0]*0.01f;
					pPtc->fvPos[1] += pPtc->fvVel[1]*0.01f;
				}
			}
		}
	}
}

void DrawParticles(BITMAP* pBmp, int dwX, int dwY)
{
	int lp;
	particle_p pPtc=g_svParticles;
	for(lp=0; lp<MAX_PARTICLES; ++lp, ++pPtc)
	{
		if(pPtc->bActive  &&  pPtc->bDraw)
		{
			if(pPtc->pBmp)
			{
				pivot_sprite(pBmp, pPtc->pBmp, pPtc->fvPos[0]-dwX, pPtc->fvPos[1]-dwY, pPtc->pBmp->w>>1, pPtc->pBmp->h>>1, ftofix(pPtc->fAngle));
			}
			else
			{
				if(pPtc->bLarge)
					circlefill(pBmp, pPtc->fvPos[0]-dwX, pPtc->fvPos[1]-dwY, 1, pPtc->dwColor);
				else
					putpixel(pBmp, pPtc->fvPos[0]-dwX, pPtc->fvPos[1]-dwY, pPtc->dwColor);
			}
		}
	}
}
