#include <allegro.h>
#include <winalleg.h>
#include "dll_shared.h"
#include "Reflect.h"

reflection_list_t g_svReflections;

void CreateReflection(int dwType, int dwX1, int dwY1, int dwX2, int dwY2)
{
	reflection_t sReflect;

	sReflect.dwType = dwType;
	sReflect.dwvPos[0] = dwX1;
	sReflect.dwvPos[1] = dwY1;
	sReflect.dwvSize[0] = dwX2-dwX1+1;
	sReflect.dwvSize[1] = dwY2-dwY1+1;
	sReflect.pBuffer = create_bitmap(sReflect.dwvSize[0]+(dwType==RT_WATER?20:0), sReflect.dwvSize[1]);

	g_svReflections.push_back(sReflect);
}

void ClearReflections()
{
	for(reflection_list_t::iterator iPos=g_svReflections.begin(); iPos!=g_svReflections.end(); ++iPos)
	{
		destroy_bitmap(iPos->pBuffer);
	}

	g_svReflections.clear();
}

void RenderReflections(BITMAP* pBmp, int dwX, int dwY)
{
	for(reflection_list_t::iterator iPos=g_svReflections.begin(); iPos!=g_svReflections.end(); ++iPos)
	{
		if(iPos->dwvPos[0]-dwX < SCREEN_W  &&  iPos->dwvPos[1]-dwY < SCREEN_H  &&  iPos->dwvPos[0]+iPos->dwvSize[0]-dwX > 0  &&  iPos->dwvPos[1]+iPos->dwvSize[1]-dwY > 0)
		{
			switch(iPos->dwType)
			{
			case RT_UP:
				{
					clear_to_color(iPos->pBuffer, makecol(255, 0, 255));
					blit(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]-iPos->dwvSize[1]-dwY, 0, 0, iPos->dwvSize[0], iPos->dwvSize[1]);
					draw_sprite_v_flip(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]-dwY);
					break;
				}
			case RT_DOWN:
				{
					clear_to_color(iPos->pBuffer, makecol(255, 0, 255));
					blit(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]+iPos->dwvSize[1]-dwY, 0, 0, iPos->dwvSize[0], iPos->dwvSize[1]);
					draw_sprite_v_flip(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]-dwY);
					break;
				}
			case RT_LEFT:
				{
					clear_to_color(iPos->pBuffer, makecol(255, 0, 255));
					blit(pBmp, iPos->pBuffer, iPos->dwvPos[0]-iPos->dwvSize[0]-dwX, iPos->dwvPos[1]-dwY, 0, 0, iPos->dwvSize[0], iPos->dwvSize[1]);
					draw_sprite_h_flip(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]-dwY);
					break;
				}
			case RT_RIGHT:
				{
					clear_to_color(iPos->pBuffer, makecol(255, 0, 255));
					blit(pBmp, iPos->pBuffer, iPos->dwvPos[0]+iPos->dwvSize[0]-dwX, iPos->dwvPos[1]-dwY, 0, 0, iPos->dwvSize[0], iPos->dwvSize[1]);
					draw_sprite_h_flip(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX, iPos->dwvPos[1]-dwY);
					break;
				}
			case RT_WATER:
				{
					clear_to_color(iPos->pBuffer, makecol(255, 0, 255));
					blit(pBmp, iPos->pBuffer, iPos->dwvPos[0]-dwX-10, iPos->dwvPos[1]-iPos->dwvSize[1]-dwY, 0, 0, iPos->dwvSize[0]+20, iPos->dwvSize[1]);
					int dwOX;
					int dwSX = iPos->dwvPos[0]-dwX;
					int dwSY = iPos->dwvPos[1]-dwY;
					for(int lp=0; lp<iPos->dwvSize[1]; lp++)
					{
						dwOX = fsin(lp*16.0f+((g_pImports->dwGameTime*2)%256))*4.0f+10;
						masked_blit(iPos->pBuffer, pBmp, dwOX, iPos->dwvSize[1]-lp-1, dwSX, dwSY+lp, iPos->dwvSize[0], 1);
					}
					break;
				}
			}
		}
	}
}
