#include <allegro.h>
#include <winalleg.h>
#include "Refract.h"

refractor_p LoadRefractor(string sFile)
{
	BITMAP* pBmp = load_bitmap(("Data\\Sprites\\"+sFile).c_str(), NULL);
	if(!pBmp)
		return NULL;

	refractor_p pRefract = new refractor_t;
	if(!pRefract)
		return NULL;
	pRefract->dwvSize[0] = pBmp->w;
	pRefract->dwvSize[1] = pBmp->h;
	pRefract->pvLines.resize(pBmp->h, NULL);
	pRefract->pBuffer = pBmp;

	int lx, ly, dwM;
	char* iPos;
	for(ly=0; ly<pBmp->h; ly++)
	{
		pRefract->pvLines[ly] = iPos = (char*)malloc(pBmp->w*2);
		for(lx=0; lx<pBmp->w; lx++)
		{
			if(!lx)
			{
				dwM = getr(getpixel(pBmp, lx, ly));
			}
			else if(lx == pBmp->w-1)
			{
				dwM = -getr(getpixel(pBmp, lx, ly));
			}
			else
			{
				dwM = getr(getpixel(pBmp, lx+1, ly))-getr(getpixel(pBmp, lx-1, ly));
			}
			dwM /= 2;
			*iPos = dwM;
			++iPos;

			if(!ly)
			{
				dwM = getr(getpixel(pBmp, lx, ly));
			}
			else if(ly == pBmp->h-1)
			{
				dwM = -getr(getpixel(pBmp, lx, ly));
			}
			else
			{
				dwM = getr(getpixel(pBmp, lx, ly+1))-getr(getpixel(pBmp, lx, ly-1));
			}
			dwM /= 2;
			*iPos = dwM;
			++iPos;
		}
	}

	return pRefract;
}

void DrawRefractor(BITMAP* pDest, refractor_p pRefract, int dwX, int dwY, float fRefScale)
{
	int dwSX = 0;
	int dwSY = 0;
	int dwW = pRefract->dwvSize[0];
	int dwH = pRefract->dwvSize[1];

	if(dwX+dwW >= pDest->w)
	{
		dwW = pDest->w-dwX;
	}
	if(dwY+dwH >= pDest->h)
	{
		dwH = pDest->h-dwY;
	}
	if(dwX < 0)
	{
		dwW += dwX;
		dwSX -= dwX;
	}
	if(dwY < 0)
	{
		dwH += dwY;
		dwSY -= dwY;
	}

	if(dwW <= 0  ||  dwH <= 0)
		return;

	int lx, ly;
	char* iPos;
	for(ly=dwSY; ly<dwH; ly++)
	{
		iPos = pRefract->pvLines[ly]+dwSX;
		for(lx=dwSX; lx<dwW; lx++)
		{
			putpixel(pRefract->pBuffer, lx, ly, getpixel(pDest, lx+dwX+iPos[0]*fRefScale, ly+dwY+iPos[1]*fRefScale));
			iPos += 2;
		}
	}

	blit(pRefract->pBuffer, pDest, dwSX, dwSY, dwX+dwSX, dwY+dwSY, dwW, dwH);
}
