#ifndef TILE_H
#define TILE_H

#include <string>

using namespace std;

typedef struct tileset_s {
	BITMAP*					pMainBmp;
	bool					bTransparent;
	int						dwCount;
	int						dwWidth;
	int						dwHeight;
	BITMAP*					pvTiles[256];
} tileset_t, *tileset_p;

typedef struct tilemap_s {
	string					sName;
	int						dwSize[4];
	short*					pvvLayers[4];
} tilemap_t, *tilemap_p;

tileset_p BuildTiles(BITMAP* pBmp);
void DeleteTiles(tileset_p pTiles);
tilemap_p LoadTileMap(string sDir);
void SaveTileMap(string sDir, tilemap_p pMap);
void DrawTile(BITMAP* pBmp, tileset_p* pvTiles, int dwTile, int dwX, int dwY);
void DrawTileMap(BITMAP* pBmp, tilemap_p pMap, tileset_p* pvTiles, int dwX, int dwY, bool* bvLayers);
void PlaceTile(tilemap_p pMap, tileset_p* pvTiles, int dwStart, int dwW, int dwH, int dwX, int dwY, int dwLayer);
void DeleteTile(tilemap_p pMap, int dwW, int dwH, int dwX, int dwY, int dwLayer);
void DeleteTileMap(tilemap_p& pMap);

#endif // TILE_H
