#ifndef GBEVENTHANDLER_H
#define GBEVENTHANDLER_H

#include <deque>

using namespace std;

#define GBE_MOUSE_LEFT_DOWN		1
#define GBE_MOUSE_RIGHT_DOWN	2
#define GBE_MOUSE_MIDDLE_DOWN	3
#define GBE_MOUSE_LEFT_UP		4
#define GBE_MOUSE_RIGHT_UP		5
#define GBE_MOUSE_MIDDLE_UP		6
#define GBE_KEY_PRESS			7

typedef union gb_event_s {
	int						dwAll;
	struct {
		unsigned char			ucEvent;
		short					wKey;
		unsigned char			ucMod;
	};
} gb_event_t, *gb_event_p;

class CGUIEventHandler
{
public:
							CGUIEventHandler();
	virtual					~CGUIEventHandler();

	static void				AddEvent(gb_event_t sEvent);
	static gb_event_t		GetEvent();
	static void				Register();

	static void				cbKeyboard(int dwKey);
	static void				cbMouse(int dwFlags);


	deque<gb_event_t>			svEvents;

	static CGUIEventHandler*	pEventHandler;

};

#endif // GBEVENTHANDLER_H
